#include 	"standard.h"

#define A_POTIEXT 0
#define O_RUN 		PB4
#define I_INPUT		PB1
#define O_RELAIS	PB2

#define TIME_START 	0

void ADC_init(void);
int read_ADC(char canal);


uint8_t period =50,run;
uint16_t Poti_Wert,Time;
volatile char flag;

int main (void)
{
	TCCR0B |= (1<<CS02)|(1<<CS00);
	TIMSK0 |= (1<<TOIE0);
	ADC_init();
	run= period;
	sei();
	Poti_Wert = read_ADC(A_POTIEXT);
	DDRB |= (1<<O_RUN)|(1<<O_RELAIS);
	OSCCAL = 0x7f;
	while(1)
	{
		period = read_ADC(A_POTIEXT);
		if (PINB & (1<<I_INPUT)) // eins
		{
			
			PORTB &= ~(1<<O_RELAIS);
			//Time = 200;
		}
		if ( (!(PINB & (1<<I_INPUT))) &&(!(flag &(1<<0))) ) //null
		{
			flag |= (1<<0);
			Time = 300;
			
		}
		if  ( (Time==0) && (!(PINB & (1<<I_INPUT))) )
		{
			PORTB |= (1<<O_RELAIS);
			flag &= ~(1<<0);
		}
	}
}


ISR(TIM0_OVF_vect)
{
	TCNT0 = (unsigned char)(signed short)-(XTAL / 1024 * 10e-3 + 0.5);	// preload for 10ms
	//PORTB ^=(1<<O_RUN);
	run--;
	if (run==0)
	{
		run = period;
		PORTB ^=(1<<O_RUN);
	}
	if  (Time!=0)
	{
		Time--;
	}
	
}


void ADC_init(void)
{
	ADCSRA = (1<<ADEN) | (1<<ADPS2) | (1<<ADPS1) ;  // ADC aktivieren und Prescaler auf 64
		//ADMUX |=  (1<<REFS0) ; 	//vermutung !!!									// interne Referenzspannung nutzen 
}

int read_ADC(char canal)
{
	ADMUX &= 0b01100000;									// Untere Bits lschen 
	ADMUX+= canal;                      					// Kanal waehlen
	ADCSRA |= (1<<ADSC);									// eine Wandlung "single conversion"
	while ( ADCSRA & (1<<ADSC) );							// auf Abschluss der Konvertierung warten
	return(ADC);				
}
